/*

This modules prvides the code for PAM support in JABBER

*/

#include "jsm.h"
#include <security/pam_appl.h>
#include <security/pam_misc.h>


int my_conversation(
	int num_msg, 
	const struct pam_message **msgm,
	struct pam_response **response, 
	void *appdata_ptr)
{
int count=0;
struct pam_response *reply;

    log_debug(ZONE,"JAMES conversation, %d items",num_msg);
    reply = (struct pam_response *) calloc(num_msg, sizeof(struct pam_response));
    for (count=0; count < num_msg; ++count) 
	{
	switch (msgm[count]->msg_style)
	    {
	    case PAM_PROMPT_ECHO_OFF:
	    case PAM_PROMPT_ECHO_ON:
		    log_debug(ZONE,"JAMES conversation '%s'",appdata_ptr);
		    reply[count].resp_retcode = 0;
		    reply[count].resp = strdup(appdata_ptr);
		    break;
	    }
	}
    *response = reply;
    return PAM_SUCCESS;
}



int pam_authentication_ok(char * user, char * pass)
{
struct pam_conv conv;
pam_handle_t *pamh=NULL;
int ret,so_far=0;

    log_debug(ZONE,"JAMES pam_authentication_ok '%s','%s'",pass,user);

    conv.appdata_ptr = (void *) pass;
    conv.conv = my_conversation;

    ret = pam_start("jabberd", user, &conv, &pamh);
    if (ret == PAM_SUCCESS) { so_far=1; ret = pam_fail_delay(pamh, 1); }
    if (ret == PAM_SUCCESS) { so_far=2; ret = pam_authenticate(pamh, 0);  }
    if (ret == PAM_SUCCESS) { so_far=3; ret = pam_acct_mgmt(pamh, 0); }
    if (ret == PAM_SUCCESS) { so_far=4; ret = pam_end(pamh,ret); }

    log_debug(ZONE,"JAMES pam_authentication_ok(so_far=%d, ret=%d) return %d",
    	so_far,ret,((ret==PAM_SUCCESS) ? 1:0));

    return ((ret==PAM_SUCCESS) ? 1:0);
}



int pam_new_user_ok(char * user,char * pass)
{
    log_debug(ZONE,"JAMES pam_new_user_ok '%s','%s'",pass,user);
    return pam_authentication_ok(user,pass);
}



int pam_existing_user_ok(char * user,char * pass)
{
    log_debug(ZONE,"JAMES pam_existing_user_ok '%s','%s'",pass,user);
    return pam_authentication_ok(user,pass);
}



int pam_in_use()
{
    log_debug(ZONE,"JAMES pam_in_use = %d\n",(getenv("USE_PAM")!=NULL)?1:0);
    if (getenv("USE_PAM")!=NULL) return 1;
    return 0;
}
